'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _SelectOne = require('./SelectOne');

var _SelectOne2 = _interopRequireDefault(_SelectOne);

var _SelectMany = require('./SelectMany');

var _SelectMany2 = _interopRequireDefault(_SelectMany);

var _ = require('.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Form = function Form(props) {
  var className = props.className,
      style = props.style,
      values = props.values,
      touched = props.touched,
      errors = props.errors,
      children = props.children,
      handleChange = props.handleChange,
      handleSubmit = props.handleSubmit,
      setFieldValue = props.setFieldValue,
      setFieldTouched = props.setFieldTouched,
      isSubmitting = props.isSubmitting;


  var renderError = function renderError(type) {
    return errors && errors[type] && touched && touched[type] && _react2.default.createElement(
      'div',
      { className: 'form__error' },
      errors[type]
    );
  };

  var renderSelectManyWithCompositionSocket = function renderSelectManyWithCompositionSocket(_ref) {
    var type = _ref.type,
        label = _ref.label,
        options = _ref.options,
        currentOptions = _ref.currentOptions,
        renderTrigger = _ref.renderTrigger;

    return _react2.default.createElement(
      'div',
      { className: 'form__socket form__select__socket' },
      _react2.default.createElement(
        'div',
        { className: 'form__label form__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectMany2.default,
        {
          currentOptions: values[type] ? (0, _keys2.default)(values[type]).map(function (v) {
            return {
              value: v,
              label: options.find(function (o) {
                return o.value === v;
              }).label
            };
          }) : [],
          options: options,
          renderTrigger: renderTrigger,
          onChange: function onChange(value) {
            setFieldValue(type, value.reduce(function (acc, v) {
              acc[v.value] = 0;
              return acc;
            }, {}));
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref2) {
          var getChildProps = _ref2.getChildProps,
              getChildrenProps = _ref2.getChildrenProps,
              currentOptions = _ref2.currentOptions;
          return _react2.default.createElement(
            'div',
            (0, _extends4.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends4.default)({}, getChildProps({
                  option: { value: option.value, label: option.label }
                }), {
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      ),
      values[type] && (0, _keys2.default)(values[type]).map(function (component) {
        return _react2.default.createElement(
          'div',
          { key: component, className: 'form__component' },
          _react2.default.createElement(
            'div',
            { className: 'form__component__label' },
            options.find(function (o) {
              return o.value === component;
            }).label
          ),
          _react2.default.createElement('input', {
            className: 'form__component__input',
            id: component,
            type: 'number',
            value: values[type][component],
            onChange: function onChange(v) {
              setFieldValue(type, (0, _extends4.default)({}, values[type], (0, _defineProperty3.default)({}, component, v.target.value)));
            }
          })
        );
      })
    );
  };

  var renderSelectManySocket = function renderSelectManySocket(_ref3) {
    var type = _ref3.type,
        label = _ref3.label,
        options = _ref3.options,
        currentOptions = _ref3.currentOptions,
        renderTrigger = _ref3.renderTrigger;

    return _react2.default.createElement(
      'div',
      { className: 'form__socket form__select__socket' },
      _react2.default.createElement(
        'div',
        { className: 'form__label form__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectMany2.default,
        {
          currentOptions: currentOptions,
          options: options,
          renderTrigger: renderTrigger,
          onChange: function onChange(value) {
            setFieldValue(type, value);
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref4) {
          var getChildProps = _ref4.getChildProps,
              getChildrenProps = _ref4.getChildrenProps,
              currentOptions = _ref4.currentOptions;
          return _react2.default.createElement(
            'div',
            (0, _extends4.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends4.default)({}, getChildProps({
                  option: { value: option.value, label: option.label }
                }), {
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      )
    );
  };

  var renderSelectOneSocket = function renderSelectOneSocket(_ref5) {
    var type = _ref5.type,
        label = _ref5.label,
        options = _ref5.options;

    return _react2.default.createElement(
      'div',
      { className: 'form__socket form__select__socket' },
      _react2.default.createElement(
        'div',
        { className: 'form__label form__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectOne2.default,
        {
          renderTrigger: function renderTrigger(_ref6) {
            var isOn = _ref6.isOn,
                currentOption = _ref6.currentOption,
                getTriggerProps = _ref6.getTriggerProps;
            return _react2.default.createElement(
              _Button2.default,
              (0, _extends4.default)({
                type: 'caretdown',
                isOn: isOn
              }, getTriggerProps({
                className: 'selectone__trigger',
                style: { border: '1px solid #ccc' }
              }), {
                colors: _.buttonStyles.monochrome
              }),
              currentOption ? currentOption.label : ''
            );
          },
          options: options,
          currentOption: values[type],
          onChange: function onChange(value) {
            setFieldValue(type, value);
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref7) {
          var getChildProps = _ref7.getChildProps,
              getChildrenProps = _ref7.getChildrenProps,
              currentOption = _ref7.currentOption,
              toggleIsOn = _ref7.toggleIsOn;
          return _react2.default.createElement(
            'div',
            (0, _extends4.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends4.default)({}, getChildProps({
                  option: { value: option.value, label: option.label },
                  onClick: toggleIsOn
                }), {
                  isOn: currentOption.value === option.value,
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      )
    );
  };

  var renderSubmitButton = function renderSubmitButton() {
    var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var label = _ref8.label,
        props = (0, _objectWithoutProperties3.default)(_ref8, ['label']);
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends4.default)({
        invert: true,
        colors: 'surfing',
        onClick: handleSubmit,
        dataTestId: 'submit',
        disabled: isSubmitting,
        style: { width: '24rem', borderRadius: '.25rem' }
      }, props),
      label
    );
  };

  var renderTextInputSocket = function renderTextInputSocket(_ref9) {
    var type = _ref9.type,
        label = _ref9.label,
        sublabel = _ref9.sublabel,
        _ref9$options = _ref9.options,
        options = _ref9$options === undefined ? { required: true, autoFocus: false, autoComplete: '' } : _ref9$options,
        props = (0, _objectWithoutProperties3.default)(_ref9, ['type', 'label', 'sublabel', 'options']);

    return _react2.default.createElement(
      'div',
      (0, _extends4.default)({ className: 'form__socket' }, props),
      _react2.default.createElement('input', {
        id: type,
        className: 'form__socket__input form__socket__input__' + type.toLowerCase(),
        type: 'text',
        required: options.required ? options.required : true,
        autoFocus: options.autoFocus ? options.autoFocus : false,
        value: values[type],
        autoComplete: options.autoComplete ? options.autoComplete : '',
        onChange: handleChange,
        onBlur: function onBlur() {
          return setFieldTouched(type);
        }
      }),
      _react2.default.createElement(
        'div',
        { className: 'form__label form__socket__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement('div', { className: 'form__socket__bar' }),
      sublabel && _react2.default.createElement(
        'div',
        { className: 'form__socket__sublabel' },
        sublabel
      ),
      renderError(type)
    );
  };

  var renderGroup = function renderGroup(_ref10) {
    var label = _ref10.label,
        renderChildren = _ref10.renderChildren;
    return _react2.default.createElement(
      'div',
      { className: 'form__group' },
      _react2.default.createElement(
        'div',
        { className: 'form__label form__group__label' },
        label
      ),
      _react2.default.createElement(
        'div',
        { className: 'form__children form__group__children' },
        renderChildren()
      )
    );
  };
  var renderCheckboxSocket = function renderCheckboxSocket(_ref11) {
    var label = _ref11.label,
        type = _ref11.type;
    return _react2.default.createElement(
      'div',
      { className: 'form__checkbox' },
      _react2.default.createElement(
        'div',
        { className: 'form__label form__checkbox__label' },
        label
      ),
      _react2.default.createElement('input', {
        id: type,
        className: 'form__checkbox__input',
        type: 'checkbox',
        checked: values[type],
        onChange: handleChange
      })
    );
  };

  return _react2.default.createElement(
    'form',
    {
      onSubmit: handleSubmit,
      className: className ? 'form ' + className : 'form',
      style: style
    },
    children({
      renderTextInputSocket: renderTextInputSocket,
      renderSelectManyWithCompositionSocket: renderSelectManyWithCompositionSocket,
      renderSelectOneSocket: renderSelectOneSocket,
      renderSelectManySocket: renderSelectManySocket,
      renderCheckboxSocket: renderCheckboxSocket,
      renderGroup: renderGroup,
      renderSubmitButton: renderSubmitButton
    }),
    errors.firebase && _react2.default.createElement(
      'div',
      {
        'data-testid': 'registeraccountmodal-formerror-firebase',
        className: 'input-feedback'
      },
      'error!',
      errors.firebase
    ),
    _react2.default.createElement('input', { type: 'submit', style: { visibility: 'hidden', height: 0, width: 0 } })
  );
};

exports.Form = Form;
Form.defaultProps = {
  handleSubmit: function handleSubmit() {
    return console.log('Form: handleSubmit');
  },
  style: {}
};
var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['values', 'touched', 'errors', 'children']), (0, _recompose.lifecycle)({
  componentDidMount: function componentDidMount() {
    var onMount = this.props.onMount;

    onMount && onMount();
  },
  componentWillUnmount: function componentWillUnmount() {
    var onUnmount = this.props.onUnmount;

    onUnmount && onUnmount();
  }
}));

exports.default = enhance(Form);