'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _sharedHandlers = require('./sharedHandlers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SinglePageModal = function SinglePageModal(_ref) {
  var _ref$demoModeIsOn = _ref.demoModeIsOn,
      demoModeIsOn = _ref$demoModeIsOn === undefined ? false : _ref$demoModeIsOn,
      noCloseModalButton = _ref.noCloseModalButton,
      style = _ref.style,
      className = _ref.className,
      onClick = _ref.onClick,
      onMount = _ref.onMount,
      onUnmount = _ref.onUnmount,
      children = _ref.children,
      renderTrigger = _ref.renderTrigger,
      renderCloseModalButton = _ref.renderCloseModalButton,
      renderHeader = _ref.renderHeader,
      dataTestId = _ref.dataTestId,
      renderBody = _ref.renderBody,
      modalIsOpen = _ref.modalIsOpen,
      openModal = _ref.openModal,
      closeModal = _ref.closeModal,
      renderButtons = _ref.renderButtons,
      useStyleTemplate = _ref.useStyleTemplate,
      backgroundProps = _ref.backgroundProps,
      externalModalIsOpen = _ref.externalModalIsOpen,
      customStyleTemplate = _ref.customStyleTemplate;

  var styleTemplate = customStyleTemplate ? customStyleTemplate : useStyleTemplate ? _defaultStyles.modalStyleTemplates[useStyleTemplate] : {};

  var getTriggerProps = function getTriggerProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref2.style,
        _onClick = _ref2.onClick,
        className = _ref2.className,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['style', 'onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        openModal();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__trigger ' + className : 'modal__trigger',
      style: style
    }, props);
  };
  var getBackgroundProps = function getBackgroundProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick2 = _ref3.onClick,
        style = _ref3.style,
        className = _ref3.className,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'style', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        closeModal();
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__background ' + className : 'modal__background',
      style: (0, _extends3.default)({}, styleTemplate.background, style)
    }, props);
  };
  var renderModalDialog = function renderModalDialog() {
    return _react2.default.createElement(_ModalDialog2.default, {
      useStyleTemplate: useStyleTemplate,
      customStyleTemplate: customStyleTemplate,
      style: style,
      className: className,
      closeModal: closeModal,
      dataTestId: dataTestId,
      onClick: onClick,
      renderBody: renderBody ? renderBody : children,
      renderHeader: renderHeader,
      noCloseModalButton: noCloseModalButton,
      renderButtons: renderButtons,
      renderCloseModalButton: renderCloseModalButton,
      onMount: onMount,
      onUnmount: onUnmount
    });
  };
  var renderTriggerFork = function renderTriggerFork(typeofRenderTrigger) {
    switch (typeofRenderTrigger) {
      case 'function':
        return renderTrigger({
          getTriggerProps: getTriggerProps
        });
      case 'string':
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getTriggerProps()),
          renderTrigger
        );
      default:
        return null;
    }
  };
  return _react2.default.createElement(
    _react.Fragment,
    null,
    renderTriggerFork(typeof renderTrigger === 'undefined' ? 'undefined' : (0, _typeof3.default)(renderTrigger)),
    demoModeIsOn && renderModalDialog(),
    _react2.default.createElement(
      _RTGTransition2.default,
      {
        in: typeof externalModalIsOpen !== 'undefined' ? externalModalIsOpen : modalIsOpen
      },
      function (_ref4) {
        var style = _ref4.style;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getBackgroundProps({
            style: (0, _extends3.default)({}, style, backgroundProps.style),
            className: backgroundProps.className
          })),
          renderModalDialog()
        );
      }
    )
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  noCloseModalButton: false,
  onCloseModal: function onCloseModal() {
    return null;
  },
  onOpenModal: function onOpenModal() {
    return null;
  },
  onMount: function onMount() {
    return null;
  },
  onUnmount: function onUnmount() {
    return null;
  },
  useStyleTemplate: 'default',
  backgroundProps: {}
}), (0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withHandlers)((0, _extends3.default)({}, _sharedHandlers.modalHandlers)), (0, _recompose.setPropTypes)({
  modalIsOpen: _propTypes2.default.bool.isRequired,
  toggleModalIsOpen: _propTypes2.default.func.isRequired
}));

exports.default = enhance(SinglePageModal);